* PROMPT
*
* pjwitte 2o22+
* All code is my own work except as and where stated
*
* V0.01, pjw, 2022 Feb 23
*
* Compatible with QDOS, Minerva and SMSQ/E. Only tested on SMSQ/E!
*

        section code

        xdef PROMPT

        xref chan_d6,sbu_prompt

        include dev8_keys_sbasic
        include dev8_keys_qlv

*
PROMPT
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* choice% = PROMPT([#ch,] prompt$ [, option1$ [, option2$ [,..optionN$]]])
*
* where
*       ch      is an optional console channel number, default #1
*       prompt$ is the prompt string, eg '<Y/N>? '
*       options strings are acceptable key codes to return on, eg
*               option1$ = 'Yy' & CHR$(10), and
*               option2$ = 'Nn' & CHR$(27)
*               If no option string is provided the function returns on any key
*       choice% is option number 1..N (or -1 or keycode. See manual)
*


        moveq #1,d6             default channel, if none specified
        bsr chan_d6             convert channel number to channel ID

        move.l sb_arthp(a6),d7  d7 = empty stack pointer

        move.w sb.gtstr,a2
        jsr (a2)                get some strings
        bne.s ret

        move.w d3,d4            count pars
        beq.s err_bp             too few is bad

        subq.w #1,d4            dont count prompt text

        bsr sbu_prompt
        bpl.s ok

        cmpi.w #-1,d0           incomplete is valid return(?)
        bne.s ret

        move.w d0,d4            dont know if this makes sense..

ok
        subq.l #2,d7            leave room for int
        move.l d7,sb_arthp(a6)  reset RI stack
        move.l d7,a1
        move.w d4,(a6,a1.l)     int to return

        moveq #ar.int,d4        tell BASIC
        moveq #0,d0             all ok

ret
        rts

err_bp
        moveq #-15,d0
        rts

*
        end
