* Set default or given channel V0.2   PUBLIC DOMAIN by Tony Tebby  QJUMP
* V0.03 - getpars, modified by pjwitte
* 0.04, pjw, 2019 Jun 29, shaved off two bytes at ##
* 0.04, pjw, 2022 Feb 23, no getpars
*
* call parameters   : a3 and a5 standard pointers to name table for parameters
* return parameters : d6 pointer to channel table
*                     a0 channel id
*                     d3 smashed
*                     a3 updated if used
         section code

         xdef    channel,chan_get,chan_d6,chan_look,chan_par

         include dev8_keys_sbasic
         include dev8_keys_qlv

*
channel
        moveq   #3,d6           ;default is channel #3

chan_d6
        cmpa.l  a3,a5           ;are there any parameters?
        ble.s   chan_look       ;... no

chan_par
        btst    #7,1(a6,a3.l)   ;has the first parameter a hash?
        beq.s   chan_look       ;... no

chan_get
        move.l  a5,a4           save last par pointer
        lea.l   8(a3),a5        bracket first par
        move.w  sb.gtint,a2     get one int
        jsr     (a2)
        bne.s   chan_exit

        movea.l a5,a3           done with first par
        movea.l a4,a5           restore last par pointer

        move.w  0(a6,a1.l),d6   ;get value in d6 to replace the default
        addq.l  #2,sb_arthp(a6) ;reset ri stack pointer  ##

*
chan_look
        mulu    #ch.len,d6      ;make d6 (long) pointer to channel table
        add.l   sb_chanb(a6),d6 ;bv.chbas
        cmp.l   sb_chanp(a6),d6 ;bv.chp is it within the table?
        bge.s   cherr_no        ;... no
        move.l  0(a6,d6.l),a0   ;set channel id
        move.w  a0,d0           ;is it open?
        bmi.s   cherr_no        ;... no
        moveq   #0,d0           ;no error

chan_exit
        rts

cherr_no
        moveq   #-6,d0          ;err.no  channel not open
        rts

*
        end
